/************************************************************************
    Event handler when scroll bar reaches the end of element.
        Programmed by Piroli YUKARINOMIYA (MagicVox)
        @see http://www.magicvox.net/archive/2010/11061735/
        @version 1.10
************************************************************************/

$.fn.whenScrollBottom = function (func, option) {
	if (!option)
		option = {};
	if (!option.snap || option.snap < 0)
		option.snap = 50;

	var _handler = function () {
		var e = this;
		if (e == document)
			e = document.body;
		if (e.scrollHeight - e.clientHeight < e.scrollTop + option.snap)
			// Unbind and Fire users function
			jQuery(this).unbind('scroll', _handler).trigger('whenScrollBottom');
	};

	return this.bind('scroll', _handler).bind('whenScrollBottom', func).each(function () {
		// Re-bind scroll handler
		this.restartScrollBottom = function () {
			jQuery(this).bind('scroll', _handler);
		};
	});
};
